''  jm_font_fbgfx.bas - jm_font
''	Copyright (C) 2005-2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Option Explicit

#include "inc1/jm_font_rt.bi"
#include "jm_font.bi"

#define USE_DRAW_STRING

' =================
' Methods
' =================

private Sub fonti_Delete alias "fonti_Delete" (byval fnt As JM_FONT_PTR)
	If (fnt) Then
		if (fnt->tmpch)     then ImageDestroy fnt->tmpch
		if (fnt->glyphdata) then deallocate   fnt->glyphdata
		if (fnt->chardata)  then deallocate   fnt->chardata
	End If
End Sub

private Function fonti_GetCharAdvanceX alias "fonti_GetCharAdvanceX" (byval fnt As JM_FONT_PTR, byval ch as integer) As Integer
	if (fnt) then
		function = fnt->w
	end if
End Function

private Function fonti_GetCharAdvanceY alias "fonti_GetCharAdvanceY" (byval fnt As JM_FONT_PTR, byval ch as integer) As Integer
	if (fnt) then
		function = fnt->h
	end if
End Function

#ifdef USE_DRAW_STRING

private function fonti_DrawChar alias "fonti_DrawChar" (byval fnt As JM_FONT_PTR, ByVal x as Integer, ByVal y as Integer, ByVal ch as Integer, ByVal fc as Integer, ByVal bc as Integer, byval trans as integer)
	dim glyptr as any ptr
	function = 0
	If (fnt) Then
		function = fnt->w
		If (fnt->glyphdata) then
			glyptr = Cast(byte ptr, fnt->glyphdata) + fnt->bpglyph * (ch and 255)
			if trans = 0 then
				Line (x,y)-(x + fnt->w - 1, y + fnt->h - 1), bc, bf
			end if
			draw string (x, y), chr(ch), fc, glyptr
		End If
	End If
End Function

#else

private function fonti_DrawChar alias "fonti_DrawChar" (byval fnt As JM_FONT_PTR, ByVal x as Integer, ByVal y as Integer, ByVal ch as Integer, ByVal fc as Integer, ByVal bc as Integer, byval trans as integer)
	dim glyptr as any ptr
	function = 0
	If (fnt) Then
		function = fnt->w
		If (fnt->glyphdata) then
			glyptr = Cast(byte ptr, fnt->glyphdata) + fnt->bpglyph * (ch and 255)
			if trans then
				line fnt->tmpch, (0,0)-(fnt->w-1,fnt->h-1),not fc, bf
				Put fnt->tmpch, (0, 0), glyptr, and
				Put (x, y), glyptr, or
				Put (x, y), fnt->tmpch, xor
			else
				line fnt->tmpch, (0,0)-(fnt->w-1,fnt->h-1),not fc, bf
				Put fnt->tmpch, (0, 0), glyptr, and
				Line (x,y)-(x + fnt->w - 1, y + fnt->h - 1), bc, bf
				Put (x, y), glyptr, or
				Put (x, y), fnt->tmpch, xor
			end if
		End If
	End If
End Function

#endif

' =================
' Font Creation
' =================

Function FONT_CreateFromBMP alias "FONT_CreateFromBMP" (ByVal w As Integer, ByVal h As Integer, byval strFile As zString ptr) As JM_FONT_PTR
	Dim tmp As Any Ptr, fnt As JM_FONT_PTR = 0
	tmp = ImageCreate(w * 16, h * 16)
	if (tmp) Then
		if Bload(*strFile, tmp) = 0 then
			fnt = FONT_CreateFromImage(w, h, tmp)
		end if
		ImageDestroy tmp
	End If
	return fnt
End Function

#ifdef USE_DRAW_STRING

Private sub FixUp1Trans(byval p as ubyte ptr, byval s as integer)
	dim j as integer
	for j = 0 to s - 1
		if (p[j]) then
			p[j] = 255
		else
			p[j] = 0
		end if
	next j
End Sub

Private sub FixUp2Trans(byval p as ushort ptr, byval s as integer)
	dim j as integer
	for j = 0 to s - 1
		if (p[j]) then
			p[j] = &hffff
		else
			p[j] = &hf81f
		end if
	next j
End Sub

Private sub FixUp4Trans(byval p as uinteger ptr, byval s as integer)
	dim j as integer
	for j = 0 to s - 1
		if (p[j]) then
			p[j] = &hffffff
		else
			p[j] = &hff00ff
		end if
	next j
End Sub

Function FONT_CreateFromImage alias "FONT_CreateFromImage" (ByVal w As Integer, ByVal h As Integer, ByVal img as Any Ptr) As JM_FONT_PTR
	Dim i as Integer, tmp as Any Ptr, sx As Integer, sy As Integer, glyptr As Any Ptr
	dim bpp as integer, j as integer
	dim p as byte ptr
	Dim fnt As JM_FONT_PTR
	fnt = Allocate(sizeof(JM_FONT_T))

	fnt->typ = JM_FONT_TYPE_BITMAP
	fnt->w = w
	fnt->h = h
	fnt->bpchar = 0
	fnt->chardata = 0
	fnt->tmpch = ImageCreate(w, h + 1)
	bpp = (*Cast(UShort Ptr, fnt->tmpch) And 7)
	fnt->bpglyph = (((bpp * w * (h + 1)) + 3) And (Not 3)) + 4
	fnt->glyphdata = Callocate(256 * fnt->bpglyph)
	fnt->handle = 0
	tmp = ImageCreate(w,h)
	For i = 0 to 255
		glyptr = Cast(Byte Ptr,fnt->glyphdata) + i * fnt->bpglyph
		sx = (i Mod 16) * w
		sy = (i  \  16) * h
		Get img, (sx, sy)-(sx + w-1,sy + h-1), tmp
		*cast(integer ptr, glyptr) = *cast(integer ptr, fnt->tmpch)
		put glyptr, (0,1), tmp, pset
		if (bpp = 1) then FixUp1Trans  cast(ubyte ptr, glyptr) + 4, w * (h + 1)
		if (bpp = 2) then FixUp2Trans  cast(ushort ptr, glyptr) + 2, w * (h + 1)
		if (bpp = 4) then FixUp4Trans  cast(uinteger ptr, glyptr) + 1, w * (h + 1)
		'' Set Character Width in first line of image
		p = cast(byte ptr, glyptr) + 4
		p[0] = 0
		p[1] = i
		p[2] = i
		p[3] = w
	Next i
  ImageDestroy tmp
	fnt->Delete = @fonti_Delete
	fnt->GetCharAdvanceX = @fonti_GetCharAdvanceX
	fnt->GetCharAdvanceY = @fonti_GetCharAdvanceY
	fnt->DrawChar = @fonti_DrawChar
	Return fnt
End Function

#else

Function FONT_CreateFromImage alias "FONT_CreateFromImage" (ByVal w As Integer, ByVal h As Integer, ByVal img as Any Ptr) As JM_FONT_PTR
	Dim i as Integer, tmp as Any Ptr, sx As Integer, sy As Integer, glyptr As Any Ptr
	dim bpp as integer, j as integer
	dim p as ubyte ptr          '' VER_COMPAT: needed for 0.15 or lower
	Dim fnt As JM_FONT_PTR
	fnt = Allocate(sizeof(JM_FONT_T))

	fnt->typ = JM_FONT_TYPE_BITMAP
	fnt->w = w
	fnt->h = h
	fnt->bpchar = 0
	fnt->chardata = 0
	fnt->tmpch = ImageCreate(w, h)
	bpp = (*Cast(UShort Ptr, fnt->tmpch) And 7)
	fnt->bpglyph = (((bpp * w * h) + 3) And (Not 3)) + 4
	fnt->glyphdata = Allocate(256 * fnt->bpglyph)
	fnt->handle = 0
	For i = 0 to 255
		glyptr = Cast(Byte Ptr,fnt->glyphdata) + i * fnt->bpglyph
		sx = (i Mod 16) * w
		sy = (i  \  16) * h
		Get img, (sx, sy)-(sx + w-1,sy + h-1), glyptr
		'' fixup for <= 8 bit modes
		if bpp = 1 then
			p = glyptr              '' VER_COMPAT: needed for 0.15 or lower
			for j = 0 to w * h - 1
				if (p[j + 4]) then    '' VER_COMPAT: needed for 0.15 or lower
			  	p[j + 4] = 255      '' VER_COMPAT: needed for 0.15 or lower
				end if                '' VER_COMPAT: needed for 0.15 or lower
				'if (Cast(Ubyte Ptr, glyptr)[j + 4]) then
			  '	Cast(Ubyte Ptr, glyptr)[j + 4] = 255
				'end if
			next j
		end if
	Next i
	fnt->Delete = @fonti_Delete
	fnt->GetCharAdvanceX = @fonti_GetCharAdvanceX
	fnt->GetCharAdvanceY = @fonti_GetCharAdvanceY
	fnt->DrawChar = @fonti_DrawChar

	Return fnt
End Function

#endif

'Function FONT_CreateFromTTF(ByVal h As Integer, byval strFile As zString ptr) As JM_FONT_PTR
'	'' not supported on fbgfx (and never will be)
'	function = 0
'end function
'
'Function FONT_CreateFromFNT(byval strFile As zString ptr) As JM_FONT_PTR
'	'' not currently supported (but will be)
'	function = 0
'end function
