#ifndef __INCLUDE_JM_FONT_H__
#define __INCLUDE_JM_FONT_H__

#ifndef __stdcall
#define __stdcall __attribute__((stdcall))
#endif

typedef enum {
	JM_FONT_TYPE_BITMAP = 0
	JM_FONT_TYPE_VARBITMAP = 1
	JM_FONT_TYPE_TTF = 2
}	JM_FONT_TYPES;

#ifndef JM_FONT_PTR_DEFINED
#define JM_FONT_PTR_DEFINED
typedef void * JM_FONT_PTR
#endif

JM_FONT_PTR __stdcall FONT_CreateFromImage (int w, int h, void * img);
JM_FONT_PTR __stdcall FONT_CreateFromBMP (int w, int h, char * strfile);
JM_FONT_PTR __stdcall FONT_CreateFromTTF (int h, char * strfile);
JM_FONT_PTR __stdcall FONT_CreateFromFNT (char * strfile);

JM_FONT_PTR __stdcall FONT_Get ();
JM_FONT_PTR __stdcall FONT_Set (JM_FONT_PTR fnt);
void        __stdcall FONT_Delete (JM_FONT_PTR fnt);

int __stdcall FONT_GetTextWidthN (char * s, int nbytes);
int __stdcall FONT_GetTextWidth (char * s);

int __stdcall FONT_GetTextHeightN (char * s, int nbytes);
int __stdcall FONT_GetTextHeight (char * s);

int __stdcall FONT_GetCharAdvanceX (int ch);
int __stdcall FONT_GetCharAdvanceY (int ch);

int __stdcall FONT_GetIndexFromX (char * s, int nbytes, int startindex, int xpos);
int __stdcall FONT_GetMaxChars (char * s, int nbytes, int w );

int __stdcall FONT_DrawChar (int x, int y, int ch, int forecolor, int backcolor, int trans);
int __stdcall FONT_DrawStringN (int x, int y, char * txt, int nbytes, int forecolor, int backcolor, int trans);
int __stdcall FONT_DrawString (int x, int y, char * txt, int forecolor, int backcolor, int trans);

extern JM_FONT_PTR FONT_curfnt;

#endif
