''  jm_boxes_fbgfx.bas - jm_gui
''	Copyright (C) 2005-2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Option Explicit

#include "inc1/jm_gui_rt.bi"
#include "jm_gui_base.bi"
#include "jm_boxes.bi"

Sub UI_DrawInit alias "UI_DrawInit" ()
''
End Sub

'' -------------------------------------------------------------------
'' DRAWING PRIMITIVES
'' -------------------------------------------------------------------

private Sub UI_DrawLine alias "UI_DrawLine" (ByVal x1 As Integer, ByVal y1 As Integer, ByVal x2 As Integer, ByVal y2 As Integer, ByVal clr As Integer)
	Line (x1,y1)-(x2,y2),clr
End Sub
private Sub UI_DrawHLine alias "UI_DrawHLine" (ByVal x As Integer, ByVal y As Integer, Byval w As Integer, ByVal clr As Integer)
	Line (x,y)-(x+w-1,y),clr
End Sub
private Sub UI_DrawVLine alias "UI_DrawVLine" (ByVal x As Integer, ByVal y As Integer, Byval h As Integer, ByVal clr As Integer)
	Line (x,y)-(x,y+h-1),clr
End Sub
private Sub UI_DrawRect alias "UI_DrawRect" (ByVal x As Integer, ByVal y As Integer, Byval w As Integer, ByVal h As Integer, ByVal clr As Integer)
	Line (x,y)-(x+w-1,y+h-1),clr,b
End Sub
private Sub UI_DrawFillRect alias "UI_DrawFillRect" (ByVal x As Integer, ByVal y As Integer, Byval w As Integer, ByVal h As Integer, ByVal clr As Integer)
	Line (x,y)-(x+w-1,y+h-1),clr,bf
End Sub

Sub UI_DrawCheckBox alias "UI_DrawCheckBox" (ByVal r As UI_RECT_T Ptr, ByVal Checked As Integer, ByVal clr As Integer)
	Dim r1 As UI_RECT_T
	Dim sz As Integer = r->w
	UI_SetRect @r1, r->x, r->y + (r->h - sz) \ 2, sz, sz
	If (Checked) Then
		UI_DrawRect r1.x, r1.y, r1.w, r1.h, clr
		UI_DrawLine (r1.x + 1, r1.y + 1, r1.x + sz - 2, r1.y + sz - 2, clr)
		UI_DrawLine (r1.x + 1, r1.y + sz - 2, r1.x + sz - 2, r1.y + 1, clr)
	else
		UI_DrawRect r1.x, r1.y, r1.w, r1.h, clr
	End If
End Sub

Private sub UI_DrawFrame_Color1(byref x as integer, byref y as integer, byref w as integer, byref h as integer, byval c1 as integer, byval c2 as integer)
	UI_DrawRect(x,y,w,h,c1)
	x += 1: y += 1: w -= 2: h -= 2
end sub

Private sub UI_DrawFrame_Color2(byref x as integer, byref y as integer, byref w as integer, byref h as integer, byval c1 as integer, byval c2 as integer)
	UI_DrawHLine (x,y,w-1, c1)
	UI_DrawVLine (x,y,h-1, c1)
	UI_DrawHLine (x, y + h - 1,w, c2)
	UI_DrawVLine (x + w - 1, y,h-1, c2)
	x += 1
	y += 1
	w -= 2
	h -= 2
end sub

Sub UI_DrawFrame alias "UI_DrawFrame"  (ByVal r As UI_RECT_T Ptr, ByVal iStyle as integer)
	Dim As Integer c1=0,c2=0
	Dim As Integer x = r->x
	Dim As Integer y = r->y
	Dim As Integer w = r->w
	Dim As Integer h = r->h

	if (iStyle and UI_FRAMESTYLE_OUTSIDE) then
		select case (iStyle And 7)
		case UI_FRAMESTYLE_UP, UI_FRAMESTYLE_DOWN, UI_FRAMESTYLE_THIN
			x -= 1: y -= 1: w += 2: h += 2
		case UI_FRAMESTYLE_EDGE
			x -= 2: y -= 2: w += 4: h += 4
		case UI_FRAMESTYLE_THICK
			x -= 4: y -= 4: w += 8: h += 8
		end select
	end if

	select case (iStyle And 7)
	case UI_FRAMESTYLE_UP
		c1 = UI_GetSysColor(UI_SYSCLR_FRAME_HIGH)
		c2 = UI_GetSysColor(UI_SYSCLR_FRAME_SHADOW)
		'' Gosub UI_DrawFrame_Color2 '' v0.16 no longer supports gosub inside proc
		UI_DrawFrame_Color2(x,y,w,h,c1,c2)

	case UI_FRAMESTYLE_DOWN
		c1 = UI_GetSysColor(UI_SYSCLR_FRAME_SHADOW)
		c2 = UI_GetSysColor(UI_SYSCLR_FRAME_HIGH)
		'' Gosub UI_DrawFrame_Color2 '' v0.16 no longer supports gosub inside proc
		UI_DrawFrame_Color2(x,y,w,h,c1,c2)

	case UI_FRAMESTYLE_THIN
		c1 = UI_GetSysColor(UI_SYSCLR_FRAME_OUTLINE)
		'' Gosub UI_DrawFrame_Color1 '' v0.16 no longer supports gosub inside proc
		UI_DrawFrame_Color1(x,y,w,h,c1,c2)

	case UI_FRAMESTYLE_EDGE
		c1 = UI_GetSysColor(UI_SYSCLR_FRAME_HIGH)
		c2 = UI_GetSysColor(UI_SYSCLR_FRAME_SHADOW)
		'' Gosub UI_DrawFrame_Color2 '' v0.16 no longer supports gosub inside proc
		UI_DrawFrame_Color2(x,y,w,h,c1,c2)
		c1 = UI_GetSysColor(UI_SYSCLR_FRAME_SHADOW)
		c2 = UI_GetSysColor(UI_SYSCLR_FRAME_HIGH)
		'' Gosub UI_DrawFrame_Color2 '' v0.16 no longer supports gosub inside proc
		UI_DrawFrame_Color2(x,y,w,h,c1,c2)

	case UI_FRAMESTYLE_THICK
		c1 = UI_GetSysColor(UI_SYSCLR_FRAME_HIGH)
		c2 = UI_GetSysColor(UI_SYSCLR_FRAME_SHADOW)
		'' Gosub UI_DrawFrame_Color2 '' v0.16 no longer supports gosub inside proc
		UI_DrawFrame_Color2(x,y,w,h,c1,c2)
		c1 = UI_GetSysColor(UI_SYSCLR_FRAME_FACE)
		'' Gosub UI_DrawFrame_Color1 '' v0.16 no longer supports gosub inside proc
		UI_DrawFrame_Color1(x,y,w,h,c1,c2)
		'' Gosub UI_DrawFrame_Color1 '' v0.16 no longer supports gosub inside proc
		UI_DrawFrame_Color1(x,y,w,h,c1,c2)
		c1 = UI_GetSysColor(UI_SYSCLR_FRAME_SHADOW)
		c2 = UI_GetSysColor(UI_SYSCLR_FRAME_HIGH)
		'' Gosub UI_DrawFrame_Color2 '' v0.16 no longer supports gosub inside proc
		UI_DrawFrame_Color2(x,y,w,h,c1,c2)
	end Select

	If (iStyle And UI_FRAMESTYLE_FILL) Then
		UI_DrawFillRect(x,y,w,h,UI_GetSysColor(UI_SYSCLR_FRAME_FACE))
	end if

	Exit Sub

''UI_DrawFrame_Color1: '' v0.16 no longer supports gosub inside proc
''	UI_DrawRect(x,y,w,h,c1)
''	x += 1: y += 1: w -= 2: h -= 2
''	Return

''UI_DrawFrame_Color2: '' v0.16 no longer supports gosub inside proc
''	UI_DrawHLine (x,y,w-1, c1)
''	UI_DrawVLine (x,y,h-1, c1)
''	UI_DrawHLine (x, y + h - 1,w, c2)
''	UI_DrawVLine (x + w - 1, y,h-1, c2)
''	x += 1
''	y += 1
''	w -= 2
''	h -= 2
''	Return

End Sub

Sub UI_DrawCaret alias "UI_DrawCaret" (byval x as integer, byval y as integer, byval w as integer, byval h as integer, byval clr as integer)
	UI_DrawFillRect x, y, w, h, clr
End Sub
