''  jm_boxes_draw.bas - jm_gui
''	Copyright (C) 2005-2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Option Explicit

#include "inc1/jm_gui_rt.bi"
#include "jm_gui_base.bi"
#include "jm_boxes.bi"
#include "../jm_font/jm_font.bi"
#include "../jm_string/jm_string.bi"

Sub UI_DrawTextN alias "UI_DrawTextN" (ByVal r As UI_RECT_T Ptr, ByVal Caption As ubyte Ptr, ByVal nBytes as integer, ByVal fc As Integer, ByVal bc As Integer, ByVal align as integer)
	Dim As Integer xx, yy
	If (caption) Then
		xx = r->x: yy = r->y
		if (align and UI_TEXT_ALIGN_CENTER) then
			xx = (r->x + (r->w - FONT_GetTextWidthN(Caption, nBytes)) \ 2)
		elseif (align and UI_TEXT_ALIGN_RIGHT) then
			xx = (r->x + (r->w - FONT_GetTextWidthN(Caption, nBytes)))
		end if

		if (align and UI_TEXT_ALIGN_MIDDLE) then
			yy = (r->y + (r->h - FONT_GetTextHeightN(Caption, nBytes)) \ 2)
		elseif (align and UI_TEXT_ALIGN_BOTTOM) then
			yy = (r->y + (r->h - FONT_GetTextHeightN(Caption, nBytes)))
		end if

		FONT_DrawStringN xx, yy, Caption, nBytes, fc, bc, 1  '' 1 = Transparent back
	End If
End Sub

Sub UI_DrawText alias "UI_DrawText" (ByVal r As UI_RECT_T Ptr, byval Caption As zString ptr, ByVal fc As Integer, ByVal bc As Integer, ByVal align as integer)
	'' FIXME: needed?
	'Dim r_ As UI_RECT_T Ptr = r
	'Dim Caption_ As zString ptr = Caption
	'Dim n_ = zstr_Len(Caption)
	'Dim fc_ As Integer = fc
	'Dim bc_ As Integer = bc
	'Dim align_ as integer = align
	'UI_DrawTextN r_, Caption_, n_, fc_, bc_, align_
	UI_DrawTextN r, Caption, zstr_Len(Caption), fc, bc, align
end sub

'' -------------------------------------------------------------------
'' STANDARD CONTROL DRAWING
'' -------------------------------------------------------------------

Sub UI_DrawStdCaption alias "UI_DrawStdCaption" (ByVal r As UI_RECT_T Ptr, ByVal flags As Integer, byval Caption As zString ptr)
	Dim xx As Integer, yy As Integer
	UI_DrawFrame r, UI_FS_CAP
	If (flags And UI_BOX_FLAG_DISABLED) = 0 Then
		UI_DrawText r, Caption, UI_GetSysColor(UI_SYSCLR_TEXT), UI_GetSysColor(UI_SYSCLR_FRAME_FACE), UI_TEXT_ALIGN_CENTER or UI_TEXT_ALIGN_MIDDLE
	Else
		UI_DrawText r, Caption, UI_GetSysColor(UI_SYSCLR_TEXT), UI_GetSysColor(UI_SYSCLR_FRAME_FACE), UI_TEXT_ALIGN_CENTER or UI_TEXT_ALIGN_MIDDLE
	End If
End Sub

Sub UI_DrawStdButton alias "UI_DrawStdButton" (ByVal r As UI_RECT_T Ptr, ByVal flags As Integer, byval Caption As zString ptr)
	Dim xx As Integer, yy As Integer, rr as UI_RECT_T
	If (flags And UI_BOX_FLAG_DISABLED) = 0 Then
		If (flags And UI_BOX_FLAG_DOWN) Then
			UI_DrawFrame r, UI_FS_BTN_DN
			UI_CopyRect @rr, r
			UI_OffsetRect @rr, 1, 1
		Else
			UI_DrawFrame r, UI_FS_BTN_UP
			UI_CopyRect @rr, r
		End If
		UI_DrawText @rr, Caption, UI_GetSysColor(UI_SYSCLR_TEXT), UI_GetSysColor(UI_SYSCLR_FRAME_FACE), UI_TEXT_ALIGN_CENTER or UI_TEXT_ALIGN_MIDDLE
	Else
		UI_DrawFrame r, UI_FS_BTN_UP
		UI_DrawText r, Caption, UI_GetSysColor(UI_SYSCLR_TEXT), UI_GetSysColor(UI_SYSCLR_FRAME_FACE), UI_TEXT_ALIGN_CENTER or UI_TEXT_ALIGN_MIDDLE
	End If
End Sub

Sub UI_DrawStdCheck alias "UI_DrawStdCheck" (ByVal r As UI_RECT_T Ptr, ByVal flags As Integer, ByVal d As UI_CHECK_T Ptr, byval Caption As zString ptr)
	Dim r1 As UI_RECT_T, r2 As UI_RECT_T
	UI_SetRect @r1, r->x,r->y,11,r->h
	UI_SetRect @r2, r->x+14,r->y,r->w-14,r->h
	If (flags And UI_BOX_FLAG_DISABLED) Then
		UI_DrawCheckBox @r1, d->checked, UI_GetSysColor(UI_SYSCLR_TEXT)
		UI_DrawText @r2, Caption, UI_GetSysColor(UI_SYSCLR_TEXT), UI_GetSysColor(UI_SYSCLR_FRAME_FACE), UI_TEXT_ALIGN_LEFT or UI_TEXT_ALIGN_MIDDLE
	Else
		UI_DrawCheckBox @r1, d->checked, UI_GetSysColor(UI_SYSCLR_TEXT)
		UI_DrawText @r2, Caption, UI_GetSysColor(UI_SYSCLR_TEXT), UI_GetSysColor(UI_SYSCLR_FRAME_FACE), UI_TEXT_ALIGN_LEFT or UI_TEXT_ALIGN_MIDDLE
	End If
End Sub
