''  jm_boxes_image_res.bas - jm_gui
''	Copyright (C) 2005-2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Option Explicit

#include "inc1/jm_gui_rt.bi"
#include "jm_gui_base.bi"
#include "jm_boxes.bi"

#define rgb_a(x) (x Shr 24) 
#define rgb_r(x) (x Shr 16 And 255) 
#define rgb_g(x) (x Shr 8 And 255) 
#define rgb_b(x) (x And 255) 

private sub SetImageHeader alias "SetImageHeader" (byval image as any ptr, byval w as integer, byval h as integer, byval bytesperpixel as integer)
	dim s as ushort ptr = image
	if (s) then
		s[0] = (w shl 3) or bytesperpixel
		s[1] = h
	end if
end sub

#if ((__FB_VER_MAJOR__ = 0) and (__FB_VER_MINOR__ <= 15))
	private sub pset32 alias "pset32" (byval image as any ptr, byval x as integer, byval y as integer, byval c as integer)
		dim as integer w,h
		dim s as ushort ptr = image
		dim p as uinteger ptr = image
		w = s[0] shr 3
		if x >= 0 and x < w then
			h = s[1]
			if y >=0 and y < h then
				dim idx as integer = w * y + x
				p[idx + 1] = c
			end if
		end if
	end sub
#else
	private sub pset32 alias "pset32" (byval image as any ptr, byval x as integer, byval y as integer, byval c as integer)
		dim as integer w,h
		w = (cast(ushort ptr, image)[0] shr 3)
		if x >= 0 and x < w then
			h = (cast(ushort ptr, image)[1])
			if y >=0 and y < h then
				dim idx as integer = w * y + x
				cast(uinteger ptr, image)[idx + 1] = c
			end if
		end if
	end sub
#endif

function UI_MakeRoundBorderImage alias "UI_MakeRoundBorderImage" (byval clr as integer,byval invert as integer, byval sz as integer) As any ptr
	dim as integer x , y, xx, yy, i, j, c, alpha
	dim as integer bs = sz \ 3
	dim as single m, d, z
	dim as integer r = rgb_r(clr)
	dim as integer g = rgb_g(clr)
	dim as integer b = rgb_b(clr)
	dim a as integer ptr = Allocate((sz * sz + 1)*sizeof(integer))
	SetImageHeader a, sz, sz, 4

	for y = 0 to sz - 1
		select case (y \ bs)
		case 0: yy =  y -bs    
		case 1: yy =  0        
		case 2: yy =  y -bs -bs
		end select
		if (invert) then yy = -yy
		for x = 0 to sz - 1
			select case (x \ bs)
			case 0: xx =  x -bs
			case 1: xx =  0
			case 2: xx =  x -bs -bs
			end select
			m = 0 
			alpha = 0
			if (invert) then xx = -xx
			d = sqr(xx * xx + yy * yy)
			if d <= bs then
				'' rounded height
				z = sqr(1 - ((d / csng(bs)) * (d / csng(bs)) ))
				'' color intensity from dot product from unit dir and unit lighting vector (slightly top/left)
				m = 0.267 * (csng(-xx) / csng(bs)) + 0.535 * (csng(-yy) / csng(bs)) + 0.807 * z
				if m >= 0 then
					if m >= 1 then m = 1
					alpha = 255
				else
					m = 0
				end if
			endif
			c = rgba(m * r, m * g, m * b, alpha)
			'' pset a,(x,y),c
			pset32(a,x,y,c)
		next x
	next y
	function = a
end function		

function UI_MakeSquareBorderImage alias "UI_MakeSquareBorderImage" (byval clr as integer,byval invert as integer, byval sz as integer) As any ptr
	dim as integer x , y, i, j, c1, c2, c3, c4
	dim as integer bs = sz \ 3
	dim as integer r = rgb_r(clr)
	dim as integer g = rgb_g(clr)
	dim as integer b = rgb_b(clr)
	dim as single m1, m2, m3, m4
	dim a as integer ptr = Allocate((sz * sz + 1)*sizeof(integer))
	SetImageHeader a, sz, sz, 4
	for j = 0 to sz \ 2 - 1 
		if j >= bs then
			m1 = 0.75: m2 = 0.75: m3 = 0.75: m4 = 0.75
		else
			if (invert) then
				m4 = 1.0 : m3 = 0.85: m2 = 0.65: m1 = 0.5
			else
				m1 = 1.0 : m2 = 0.85: m3 = 0.65: m4 = 0.5
			end if
		end if
		c1 = rgba(m1 * r, m1 * g, m1 * b, 255)
		c2 = rgba(m2 * r, m2 * g, m2 * b, 255)
		c3 = rgba(m3 * r, m3 * g, m3 * b, 255)
		c4 = rgba(m4 * r, m4 * g, m4 * b, 255)
		dim idx as integer
		for i = j to sz - 1 - j
			'pset a, (i,j),c1						'' top
			'pset a, (j,sz-1-i),c2       '' left
			'pset a, (sz-1-j,i),c3       '' right
			'pset a, (sz-1-i,sz-j-1),c4  '' bottom
			PSET32(a,i,j,c1)
			PSET32(a,j,sz-1-i,c2)
			PSET32(a,sz-1-j,i,c3)
			PSET32(a,sz-1-i,sz-j-1,c4)
		next i
	next j
	function = a
end function		
