''  jm_image.bas - jm_gui
''	Copyright (C) 2005-2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Option Explicit

#include "crt/string.bi"
#include "jm_image.bi"

Function IMAGE_Create alias "IMAGE_Create" (byval w as integer, byval h as integer, byval clr as integer, byval bitdepth as integer) as any ptr
	dim img as short ptr, dst as any ptr
	dim as integer s,i,bpp

	if (bitdepth=8) then 
		bpp = 1
	elseif (bitdepth=16) then 
		bpp = 2
	elseif ((bitdepth=24) or (bitdepth=32)) then 
		bpp = 4
	else
		return NULL
	end if

	if ((w<=0) or (h<=0)) then
		return NULL
	end if

	s = w * h

	img = Allocate(w * h * bpp + 4)
	if (img) then
		dst = img + 2
		img[0] = (w shl 3) or bpp
		img[1] = h
		if (bpp=1) then
			for i=0 to s-1
				cast(byte ptr, dst)[i] = clr and 255
			next i
		elseif (bpp=2) then
			for i=0 to s-1
				cast(short ptr, dst)[i] = clr and &hffff
			next i
		elseif (bpp=4) then
			for i=0 to s-1
				cast(integer ptr, dst)[i] = clr
			next i
		end if
	endif
	return img	
end function

sub IMAGE_Destroy alias "IMAGE_Destroy" (byval img as any ptr)
	Deallocate img
end sub

sub IMAGE_pset alias "IMAGE_pset" (byval img as any ptr, byval x as integer, byval y as integer, byval clr as integer)
	if (img) then
		dim w as ushort = Cast(ushort ptr, img)[0] shr 3
		dim h as ushort = Cast(ushort ptr, img)[1]
		dim d as ushort = Cast(ushort ptr, img)[0] and 7
		if ((x >= 0) and (y >=0) and (x < w) and (y < h)) then
			if (d=1) then
				cast(byte ptr, img)[w * y + x + 4] = clr
			elseif (d=2) then
				cast(short ptr, img)[w * y + x + 2] = clr
			elseif (d=4) then
				cast(integer ptr, img)[w * y + x + 1] = clr
			endif
		endif
	endif
end sub

function IMAGE_pget alias "IMAGE_pget" (byval img as any ptr, byval x as integer, byval y as integer) as integer
	function = 0
	if (img) then
		dim w as ushort = Cast(ushort ptr, img)[0] shr 3
		dim h as ushort = Cast(ushort ptr, img)[1]
		dim d as ushort = Cast(ushort ptr, img)[0] and 7
		if ((x >= 0) and (y >=0) and (x < w) and (y < h)) then
			if (d=1) then
				function = cast(byte ptr, img)[w * y + x + 4]
			elseif (d=2) then
				function = cast(short ptr, img)[w * y + x + 2]
			elseif (d=4) then
				function = cast(integer ptr, img)[w * y + x + 1]
			endif
		endif
	endif
end function
